#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "bmp_loader.h"
#include "img_resize.h"
#include "ANN/ANN.h"					// ANN declarations
#include "texture_synthe.h"

// texture_synthe [͉摜t@C] [o̓t@C] [o͉摜TCY] [𑜃x] [ߖTTCY....]
int main(int argc, char *argv[])
{
	unsigned char *img;
	unsigned char *example;
	unsigned char *out;
	unsigned char *zoom;
	char in_file[256] = "./test2.bmp";
	char out_file[256] = "./out";
	char file[256];
	int w, h;
	int sw, sh, zw, zh;
	int example_num;

	// p[^
	int L, max_L = 3;				// d𑜃x 2^L
	int Lw[5], Lh[5], Lptr[5];		// wK摜̊ex̃TCYƉ摜ւ̃|C^
	int LN[16] =						// exł̑d𑜋ߖTTCY
	{
		2, 1, 1,					// 摜
		0, 2, 1,					// 1/2
		0, 0, 2,					// 1/4
	};
	int out_w,  out_h;
	int ow, oh, optr;
	
	out_w = out_h = 256;
	// R}hǂݍ
	if(argc > 1)
	{
		memcpy(in_file,  argv[1], 1 + strlen(argv[1]));
		memcpy(out_file, argv[2], 1 + strlen(argv[2]));
		out_w = atoi(argv[3]);
		out_h = atoi(argv[4]);
		max_L = atoi(argv[5]);
		for(int i = 0;i < max_L * max_L;i++)
		{
			LN[i] = atoi(argv[6 + i]);
		}
	}

	// [Nm(߂ɓKɊm)
	example = new unsigned char[3 * 1024 * 1024];
	out     = new unsigned char[3 * 1024 * 1024];
	zoom    = new unsigned char[3 * 1024 * 1024];


	// wK摜ǂݍ
	load_bmp_rgb(in_file, &img, &w, &h);
	// wK摜s~bh
	gen_pyramid_rgb(img, w, h, example, Lw, Lh, Lptr, max_L);

	// ANN֌W
	ANNpointArray		dataPts;				// data points
	ANNkd_tree		   *kdTree = NULL;			// search structure
	unsigned char	   *centerPts = NULL;

	// o͉摜̃_
	init_img_by_random(&example[0], Lw[0], Lh[0], out, out_w * 2, out_h * 2);
	// d𑜏
	for(L = max_L - 1;L >= 0;L--)
	{
		// 쐬(Kd-Tree\z)
		example_num = gen_texture_dict_rgb_ANN_ML(
			example, Lw, Lh, Lptr, &LN[max_L*L], 
			L, max_L, 
			&kdTree, &dataPts, &centerPts
			);
		// ɁAeNX`s
		texture_synthe_EM_ANN_ML(
			kdTree, centerPts, &dataPts, example_num, &LN[max_L*L], 
			out, out_w, out_h, 
			L, max_L, 
			&ow, &oh, &optr,
			2.0,
			10
			);
		// ʂo
		img_double_rgb(&out[optr], ow, oh, zoom, &zw, &zh, 1 << L);
		sprintf(file, "%s_%d.bmp", out_file, L);
		write_bmp_rgb(file, zoom, zw, zh);
		// ̃x̏l͑Õxg債̂Ƃ
		img_double_rgb(&out[optr], ow, oh, &out[optr - 4 * ow * oh * 3], &ow, &oh, 2);
	}

	return 0;
};
